/* AMX Mod X
*   Get Some Health On Attack
*
* (c) Copyright 2007 by VEN
*
* This file is provided as is (no warranties)
*/

/* 	Changelog:

	0.2 [2006-02-16] by Simon Logic
	* dynamic support for friendly fire
	* support for FFA mode
	0.1
	* authorized release
*/

#include <amxmodx>
#include <fakemeta>

// plugin's main information
#define PLUGIN_NAME "Get Some Health On Attack"
#define PLUGIN_VERSION "0.2"
#define PLUGIN_AUTHOR "VEN"

#define MAX_HEALTH 100.0
#define HP_BONUS_PERCENTS 50.0


new g_cvarFFA, g_cvarFF

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)
	register_event("Damage", "event_damage", "b", "2!0")
}

public plugin_cfg()
{
	g_cvarFF = get_cvar_pointer("mp_friendlyfire")
	g_cvarFFA = get_cvar_pointer("mp_freeforall")
}

public event_damage(victim) {
	new id = get_user_attacker(victim)
	if (!is_user_alive(id) || id == victim)
		return

	new bool:bGiveHealth = false

	// NOTE: FFA mode has more priority than FF mode
	if(g_cvarFFA && get_pcvar_num(g_cvarFFA))
		bGiveHealth = true
	if(!bGiveHealth && g_cvarFF && get_pcvar_num(g_cvarFFA) && get_user_team(id) != get_user_team(victim))
		bGiveHealth = true
	
	if(bGiveHealth)
	{
		new Float:health
		pev(id, pev_health, health)
		health += float(read_data(2)) * HP_BONUS_PERCENTS / 100.0

		if (health > MAX_HEALTH)
			health = MAX_HEALTH

		set_pev(id, pev_health, health)
	}
}
